<?php
/**
 * @file
 * Contains Settings form for OTP Verification Module.
 */

function otp_settings_form($form_state = NULL) {
  $form['otp_no_of_digits'] = array(
    '#type' => 'select',
    '#options' => array(1=>1, 2=>2, 3=>3, 4=>4, 5=>5, 6=>6, 7=>7, 8=>8, 9=>9, 10=>10),
    '#required' => TRUE,
    '#default_value' => variable_get('otp_no_of_digits','6'),
    '#title' => t('Number of digits in OTP'),
    '#description' => 'The otp will be generated of these many numbers',
  );
  $email_token_help = t('Available variables are: [user:otp], [user:otp_form_url], [site:name], [site:url], [user:name], [user:mail], [site:login-url], [site:url-brief], [user:edit-url].');

  $form['otp_email'] = array(
    '#type' => 'fieldset',
    '#title' => t('OTP Email'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
    '#description' => t('Edit the otp email send to the user.') . ' ' . $email_token_help,
  );
  $form['otp_email']['otp_otp_mail_subject'] = array(
    '#type' => 'textfield',
    '#title' => t('OTP Email Subject'),
    '#required' => TRUE,
    '#description' => t('Email subject which will be send to the user'),
    '#default_value' => variable_get('otp_otp_mail_subject', 'Your Requested One Time Password'),
  );
  $email_text = _otp_otp_email();
  $form['otp_email']['otp_otp_mail_body'] = array(
    '#type' => 'textarea',
    '#title' => t('OTP Email Body'),
    '#required' => TRUE,
    '#description' => t('This email will be send with [user:otp] which will be replaced with otp value'),
    '#default_value' => variable_get('otp_otp_mail_body', $email_text),
    '#rows' => 15,
  );

  return system_settings_form($form);
}

function otp_settings_form_validate($form, $form_state = NULL) {
  $tokens = token_scan($form_state['values']['otp_otp_mail_body']);
  if (!isset($tokens['user']['otp']))
    form_set_error('otp_otp_mail_body', t('Email body should have [user:otp] token'));
}
